{{
ParallelDefs.spin - parallel bus pin definitions
Copyright (c) 2009 by John Steven Denson (jazzed)
See MIT license terms below. 
}}

con     '' Parallel Propeller Pin Definitions

  DB0PIN        = 0
  DBMASK        = %11111111
  ACKPIN        = 25            ' Should be pulled up.
  ATNPIN        = 24            ' Should be pulled up.

  LEDPIN        = 16
  LEDMSK        = %1111

  PIDMSK        = $ff           ' Up to 256 Propellers
  STPBIT        = 8             ' use for Prop to Prop data transfer
  RST           = 9             ' downstream reset control pin - reset downstream "device"
  INTPIN        = 10            ' Device->Host interrupt pin
  
con
  CMD_DONE      = 0
  CMD_RDBUF     = 1
  CMD_WRBUF     = 2
  CMD_RUNRPC    = 3
  CMD_REGRPC    = 4
  CMD_POLL      = 5             ' Host sends poll command after getting async interrupt from device
  CMD_NOP       = 6

con
  RXPIN         = 31            ' upstream receiver - get from upstream "host"
  TXPIN         = 30            ' upstream transmitter - send to upstream "host"
  DSRX          = ACKPIN        ' downstream receiver - get from downstream "device"
  DSTX          = ATNPIN        ' downstream transmitter - send to downstream "device"
  MODE          = 0             ' serial mode
  DMODE         = 3             ' serial "device mode" comm inverted
  BAUD          = 115200        ' baudrate
    
pub nada
          
{{
 TERMS OF USE: MIT License                                                           

 Permission is hereby granted, free of charge, to any person obtaining a copy
 of this software and associated documentation files (the "Software"), to deal
 in the Software without restriction, including without limitation the rights
 to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the Software is
 furnished to do so, subject to the following conditions:

 The above copyright notice and this permission notice shall be included in
 all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,ARISING FROM,
 OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 THE SOFTWARE.
}}